#ifndef MH_NodeObject_H
#define MH_NodeObject_H

#ifdef	__cplusplus

#include "MH_System.h"
#include "messiahHOST.h"

// ===============================================================
// MH_NodeObject
// ===============================================================
class MH_NodeObject
{

public:

/*	MH_NodeObject(MH_NodeObject &obj) : _messiahObj( obj._messiahObj ) {}

	// Operator overloads //
	MH_NodeObject &		operator = (void *mObj)			{ _messiahObj = mObj; return *this; }
	MH_NodeObject &		operator = (MH_NodeObject &no)	{ _messiahObj = no._messiahObj; }
*/
	// Node Create Func //
	static MH_NodeObject *		Create	(char *name, int type, int flags);
	MH_NodeObject( int mobj ) : _messiahObj(mobj) {}

	// Get Messiah Obj as an int //
	int						MessiahObj	()  { return _messiahObj; }

	// Item maintenance //
	int					Rename		(char *name, int flags);
	int					GetName		(char *name, int buffer_size);
	void				Append		(int flags);
	void				End			(int flags);
	void				Rebuild		(int flags);

	// Vertex Ops //
	int					CreatePoint	(double x, double y, double z);
	int					GetPoint	(int index, double *x, double *y, double *z);
	int					SetPoint	(int index, double x, double y, double z);
	int					NumPoints	();

	// Surface Ops //
	int					CreateSurface	(char *name);
	void				SetSurface		(int i, char *param, void *data);
	int					GetSurface		(int i, char *param, void *data);
	int					NumSurfaces		();
	
	// Polygon Ops //
	void				CreatePoly	(int numPoints, int *verList, unsigned short surfaceId, int flags);
	int					GetPoly		(int i, int *point_IDs, int array_size, int *num_points, int *surface_ID);
	int					NumPolys	();

	// Motion Ops //
	void				GetMotion		(double channels[TOTAL_NUM_CHANNELS], double time);
	void				SetMotion		(double channels[TOTAL_NUM_CHANNELS]);
	void				GetWorldPos		(double channels[3], double time);
	void				GetWorldRot		(double channels[3], double time);

private:
	// Constructors //
	MH_NodeObject() : _messiahObj(0) {}

	int					_messiahObj;
};


#endif	// __cplusplus
#endif	// MH_System_H
