/////////////////////////////////////////////////////////////
// CINEMA SDK : ANIMATION                                  //
/////////////////////////////////////////////////////////////
// VERSION    : CINEMA 4D V6 AMBER												 //
/////////////////////////////////////////////////////////////
// (c) 1989-2001 MAXON Computer GmbH, all rights reserved	 //
/////////////////////////////////////////////////////////////

#ifndef __C4D_ANIMPLUGIN_H
#define __C4D_ANIMPLUGIN_H

#include "ge_math.h"
#include "ge_prepass.h"

class PluginKey;
class PluginSequence;
class PluginTrack;
class BaseDocument;
class BaseObject;
class BaseKey;
class BaseSequence;
class BaseTrack;
class BaseTime;
class HyperFile;

#define ANIMINFO_QUICK			(1<<0)
#define ANIMINFO_REFERENCE	(1<<1)

struct ANIMPLUGIN
{
	LONG  disklevel,info;

	Bool	(*KeyAllocSettings		)(PluginKey *pk);
	void	(*KeyFreeSettings			)(PluginKey *pk);
	Bool	(*KeyCloneSettings		)(PluginKey *src, PluginKey *dst);
	Bool	(*KeyReadSettings			)(PluginKey *pk, HyperFile *hf, LONG level);
	Bool	(*KeyWriteSettings		)(PluginKey *pk, HyperFile *hf);
	Bool	(*KeyEditSettings			)(PluginKey *pk);
	Bool	(*KeyInitSettings			)(PluginKey *pk);
	Bool	(*KeyMessage					)(PluginKey *pk, LONG msg, void *data);

	Bool	(*SeqAllocSettings		)(PluginSequence *pk);
	void	(*SeqFreeSettings			)(PluginSequence *pk);
	Bool	(*SeqCloneSettings		)(PluginSequence *src, PluginSequence *dst);
	Bool	(*SeqReadSettings			)(PluginSequence *pk, HyperFile *hf, LONG level);
	Bool	(*SeqWriteSettings		)(PluginSequence *pk, HyperFile *hf);
	Bool	(*SeqEditSettings			)(PluginSequence *pk);
	Bool	(*SeqMessage					)(PluginSequence *pk, LONG msg, void *data);

	Bool	(*TrackAllocSettings	)(PluginTrack *pk);
	void	(*TrackFreeSettings		)(PluginTrack *pk);
	Bool	(*TrackCloneSettings	)(PluginTrack *src, PluginTrack *dst);
	Bool	(*TrackReadSettings		)(PluginTrack *pk, HyperFile *hf, LONG level);
	Bool	(*TrackWriteSettings	)(PluginTrack *pk, HyperFile *hf);
	Bool	(*TrackMessage				)(PluginTrack *pk, LONG msg, void *data);
	Bool  (*TrackAnimate				)(PluginTrack *pl, BaseDocument *doc, BaseObject *op, BaseSequence *seq, const BaseTime &time, LONG fps, Real fac, Real rel, BaseKey *k1, BaseKey *k2, LONG flags);

	Bool add_menu;
};

#endif
