#include "c4d_basekey.h"
#include "c4d_basesequence.h"
#include "c4d_basetrack.h"
#include "c4d_baseobject.h"

BaseTrack *BaseKey::GetTrack(void)
{
	BaseSequence *bs=GetSequence();
	if (bs) return bs->GetTrack(); else return NULL;
}

BaseObject *BaseKey::GetObject(void)
{
	BaseTrack *bs=GetTrack();
	if (bs) return bs->GetObject(); else return NULL;
}

BaseDocument *BaseKey::GetDocument(void)
{
	BaseObject *bo=GetObject();
	if (bo) return bo->GetDocument(); else return NULL;
}

BaseKey *BaseKey::GetClone(LONG flags)
{
	return C4DOS.Bk->GetClone(this,flags);
}
																				 
Bool BaseKey::CopyTo(BaseKey *dest, LONG flags)
{
	return C4DOS.Bk->CopyTo(this,dest,flags);
}

Bool BaseKey::Edit(void)
{
	return C4DOS.Bk->Edit(this);
}

void BaseKey::SetData(const BaseContainer &bc)
{
	if (!bc.Get()) return;
	C4DOS.Bk->SetData(this,bc.Get());
}

BaseContainer BaseKey::GetData(void)
{
	BaseContainer bc;
	if (!bc.Get()) return BaseContainer();
	C4DOS.Bk->GetData(this,bc.Get());
	return bc;
}

void BaseKey::SetTime(const BaseTime &time)
{
	C4DOS.Bk->SetTime(this,time);
}

BaseTime BaseKey::GetTime(void)
{
	return C4DOS.Bk->GetTime(this);
}

void PSRKey::SetP(const Vector &v)
{
	C4DOS.Bk->SetP(this,v);
}

void PSRKey::SetVL(const Vector &v)
{
	C4DOS.Bk->SetVL(this,v);
}

void PSRKey::SetVR(const Vector &v)
{
	C4DOS.Bk->SetVR(this,v);
}

Vector PSRKey::GetP(void)
{
	return C4DOS.Bk->GetP(this);
}

Vector PSRKey::GetVL(void)
{
	return C4DOS.Bk->GetVL(this);
}

Vector PSRKey::GetVR(void)
{
	return C4DOS.Bk->GetVR(this);
}

void PSRKey::SoftTangents(LONG component, BaseDocument *doc)
{
	C4DOS.Bk->SoftTangents(this,doc,component);
}

VariableTag *PLAKey::GetPointTag(void)
{
	return C4DOS.Bk->GetPointTag(this);
}

VariableTag *PLAKey::GetHermiteTag(void)
{
	return C4DOS.Bk->GetHermiteTag(this);
}

Vector TextureKey::GetPos(void)
{
	return C4DOS.Tx->GetPos(this);
}

Vector TextureKey::GetScale(void)
{
	return C4DOS.Tx->GetScale(this);
}

Vector TextureKey::GetRot(void)
{
	return C4DOS.Tx->GetRot(this);
}

Matrix TextureKey::GetMl(void)
{
	return C4DOS.Tx->GetMl(this);
}

Matrix TextureKey::GetMln(void)
{
	return C4DOS.Tx->GetMln(this);
}

void TextureKey::SetPos(const Vector &v)
{
	C4DOS.Tx->SetPos(this,v);
}

void TextureKey::SetScale(const Vector &v)
{
	C4DOS.Tx->SetScale(this,v);
}

void TextureKey::SetRot(const Vector &v)
{
	C4DOS.Tx->SetRot(this,v);
}

void TextureKey::SetMl(const Matrix &m)
{
	C4DOS.Tx->SetMl(this,m);
}

BaseMaterial *TextureKey::GetMaterial(void)
{
	return C4DOS.Tx->GetMaterial(this);
}

void TextureKey::SetMaterial(BaseMaterial *mat)
{
	C4DOS.Tx->SetMaterial(this,mat);
}

BaseKey *AllocKey(LONG type, LONG subtype)
{
	return C4DOS.Bk->Alloc(type,subtype);
}

LONG PluginKey::GetPluginID(void)
{
	return C4DOS.Bk->GetPluginID(this);
}

void *PluginKey::GetPluginData(void)
{
	return C4DOS.Bk->GetPluginData(this);
}

void PluginKey::SetPluginData(void *mem)
{
	C4DOS.Bk->SetPluginData(this,mem);
}
