#include "c4d_basekey.h"
#include "c4d_basesequence.h"
#include "c4d_basetrack.h"
#include "c4d_baseobject.h"

void BaseTrack::SetData(const BaseContainer &bc)
{
	if (!bc.Get()) return;
	C4DOS.Be->SetData(this,bc.Get());
}

BaseContainer BaseTrack::GetData(void)
{
	BaseContainer bc;
	if (!bc.Get()) return BaseContainer();
	C4DOS.Be->GetData(this,bc.Get());
	return bc;
}

BaseDocument *BaseTrack::GetDocument(void)
{
	BaseObject *bo=GetObject();
	if (bo) return bo->GetDocument(); else return NULL;
}

BaseTrack *BaseTrack::GetClone(LONG flags)
{
	return C4DOS.Be->GetClone(this,flags);
}

Bool BaseTrack::CopyTo(BaseTrack *dest, LONG flags)
{
	return C4DOS.Be->CopyTo(this,dest,flags);
}

Bool BaseTrack::InsertSequence(BaseSequence *bs, Bool check)
{
	return C4DOS.Be->InsertSequence(this,bs,check);
}

Bool BaseTrack::AnimateObject(BaseDocument *doc, BaseObject *op, const BaseTime &time, LONG flags, void *data)
{
	return C4DOS.Be->AnimateObject(this,doc,op,time,flags,data);
}

BaseSequence *BaseTrack::FindSequence(const BaseTime &time)
{
	return C4DOS.Be->FindSequence(this,time);
}

BaseSequence *BaseTrack::GetFirstSequence(void)
{
	return C4DOS.Be->GetFirstSequence(this);
}

String BaseTrack::GetName(void) 
{ 
	String str; 
	if (!str.Get()) return String(); 
	C4DOS.Be->GetName(this,str.Get()); 
	return str; 
}

BaseTrack *AllocTrack(LONG type, LONG subtype)
{
	return C4DOS.Be->Alloc(type,subtype);
}

LONG PluginTrack::GetPluginID(void)
{
	return C4DOS.Be->GetPluginID(this);
}

void *PluginTrack::GetPluginData(void)
{
	return C4DOS.Be->GetPluginData(this);
}

void PluginTrack::SetPluginData(void *mem)
{
	C4DOS.Be->SetPluginData(this,mem);
}
