#ifndef __C4DBASETRACK_H
#define __C4DBASETRACK_H

#include "c4d_baselist.h"
#include "operatingsystem.h"
#include "ge_vector.h"

class BaseObject;
class BaseDocument;
class BaseSequence;
class BaseKey;

class BaseTrack : public BaseList2D
{
	private:
		BaseTrack(void);
		~BaseTrack(void);
	public:
		BaseObject		*GetObject(void) { return (BaseObject*)C4DOS.Bl->GetMain(this); }
		BaseDocument  *GetDocument(void);

		void					SetData(const BaseContainer &bc);
		BaseContainer GetData(void);

		BaseTrack 		*GetClone(LONG flags=0);
		Bool    			CopyTo(BaseTrack *dest, LONG flags=0);

		String				GetName(void);
		BaseSequence	*GetFirstSequence(void);
		Bool					InsertSequence(BaseSequence *bs, Bool check=TRUE);
		Bool					AnimateObject(BaseDocument *doc, BaseObject *op, const BaseTime &time, LONG flags, void *data=NULL);
		BaseSequence	*FindSequence(const BaseTime &time);

		BaseTrack			*next(void) { return (BaseTrack*)C4DOS.Bl->Next(this); }
		BaseTrack			*pred(void) { return (BaseTrack*)C4DOS.Bl->Pred(this); }
};

class PluginTrack : public BaseTrack
{
	private:
		PluginTrack(void);
		~PluginTrack(void);
	public:
		LONG GetPluginID(void);
		void *GetPluginData(void);
		void SetPluginData(void *mem);
};

BaseTrack *AllocTrack(LONG type, LONG subtype=0);
#define FreeTrack(v) { if (v) C4DOS.Bl->Free(v); v=NULL;}

#endif
