#include "c4d_general.h"
#include "c4d_shaderplugin.h"
#include "c4d_file.h"
#include "c4d_basecontainer.h"

Parser *AllocParser(void)
{
	return C4DOS.Pr->Alloc();
}

void FreeParser(Parser *&pr)
{
	C4DOS.Pr->Free(pr);
	pr=NULL;
}

Bool Parser::AddVar(const String &str, Real *value)
{
	if (!str.Get()) return FALSE;
	return C4DOS.Pr->AddVar(this,str.Get(),value);
}

Bool Parser::Eval(const String &str, LONG *error, Real *res, LONG unit, LONG angletype, LONG basis)
{
	if (!str.Get()) return FALSE;
	return C4DOS.Pr->Eval(this,str.Get(),error,res,unit,angletype,basis);
}

void GeShowMouse(LONG v)
{
	C4DOS.Ge->ShowMouse(v);
}

void GeGetSysTime(LONG *year, LONG *month, LONG *day, LONG *hour, LONG *minute, LONG *second)
{
	C4DOS.Ge->GetSysTime(year,month,day,hour,minute,second);
}

String GeGetLineEnd(void)
{
	String str;
	if (!str.Get()) return String();
	C4DOS.Ge->GetLineEnd(str.Get());
	return str;
}

LONG GeGetDefaultFPS(void)
{
	return C4DOS.Ge->GetDefaultFPS();
}

LONG GeOutString(const String &str, LONG flags)
{
	if (!str.Get()) return 0;
	return C4DOS.Ge->OutString(str.Get(),flags);
}

LONG GeGetCurrentOS(void)
{
	return C4DOS.Ge->GetCurrentOS();
}

LONG GeGetByteOrder(void)
{
	return C4DOS.Ge->GetByteOrder();
}

void GeGetGray(LONG *r, LONG *g, LONG *b)
{
	C4DOS.Ge->GetGray(r,g,b);
}

Bool GeChooseColor(Vector *col)
{
	return C4DOS.Ge->ChooseColor(col);
}
																  
void GeGetSerialInfo(LONG type, SerialInfo *si)
{
	if (!si->nr.Get() || !si->name.Get() || !si->organization.Get() ||
	    !si->street.Get() || !si->city.Get() || !si->country.Get()) return;
	C4DOS.Ge->GetSerialInfo(type,si->nr.Get(),si->name.Get(),si->organization.Get(),si->street.Get(),si->city.Get(),si->country.Get());
}

LONG GeGetVersionType(void)
{
	return C4DOS.Ge->GetVersionType();
}

Bool GeRegisterPlugin(LONG type, LONG id, const String &str, void *data, LONG datasize)
{
	if (!str.Get()) return FALSE;
	if (GetC4DVersion()>=6114)
		return C4DOS.Ge->RegisterPlugin(API_VERSION,type,id,str.Get(),data,datasize);

	return C4DOS.Ge->RegisterPluginEx(API_VERSION,type,id,str.Get(),data);
}

void GePrint(const String &str)
{
	if (!str.Get()) return;
	C4DOS.Ge->Print(str.Get());
}

void SetMousePointer(LONG l)
{
	C4DOS.Ge->SetMousePointer(l);
}

Bool ShowBitmap(const Filename &fn)
{
	if (!fn.Get()) return FALSE;
	return C4DOS.Ge->ShowBitmap1(fn.Get());
}

Bool ShowBitmap(BaseBitmap *bm)
{
	return C4DOS.Ge->ShowBitmap2(bm);
}

void StopAllThreads(void)
{
	C4DOS.Ge->StopAllThreads();
}

void StatusClear(void)
{
	C4DOS.Ge->StatusClear();
}

void StatusSetSpin(void)
{
	C4DOS.Ge->StatusSetSpin();
}

void StatusSetBar(LONG p)
{
	C4DOS.Ge->StatusSetBar(p);
}

void StatusSetText(const String &str)
{
	if (!str.Get()) return;
	C4DOS.Ge->StatusSetText(str.Get());
}

void GeEventAdd(LONG messageid, ULONG p1, ULONG p2)
{
	C4DOS.Ge->EventAdd(messageid,p1,p2);
}

Bool DrawViews(LONG flags)
{
	return C4DOS.Ge->DrawViews(flags);
}

void *SendModelingCommand(LONG command, BaseDocument *doc, BaseObject *op, BaseContainer *bc, LONG mode)
{
	if (bc && !bc->Get()) return FALSE;
	return C4DOS.Ge->SendModelingCommand(command,doc,op,bc?bc->Get():NULL,mode);
}

Filename GetGlobalTexturePath(LONG i)
{
	Filename fn;
	if (!fn.Get()) return Filename();
	C4DOS.Ge->GetGlobalTexturePath(i,fn.Get());
	return fn;
}

void SetGlobalTexturePath(LONG i, const Filename &fn)
{
	if (!fn.Get()) return;
	C4DOS.Ge->SetGlobalTexturePath(i,fn.Get());
}

Bool GenerateTexturePath(const Filename &docpath, const Filename &srcname, Filename *dstname)
{
	if (!docpath.Get() || !srcname.Get() || !dstname->Get()) return FALSE;
	return C4DOS.Ge->GenerateTexturePath(docpath.Get(),srcname.Get(),dstname->Get());
}

void FlushTexture(const Filename &docpath, const String &name)
{
	if (!docpath.Get() || !name.Get()) return;
	C4DOS.Ge->FlushTexture(docpath.Get(),name.Get());
}

void FlushUnusedTextures(void)
{
	C4DOS.Ge->FlushUnusedTextures();
}

BaseContainer GetWorldContainer(void)
{
	BaseContainer bc;
	if (!bc.Get()) return BaseContainer();
	C4DOS.Ge->GetWorldContainer(bc.Get());
	return bc;
}

Vector GetWorldColor(LONG i)
{
	return C4DOS.Ge->GetColor(i);
}

void ErrorStringDialog(LONG type, Real x, Real y, LONG is)
{
	C4DOS.Ge->ErrorStringDialog(type,x,y,is);
}

Bool ReadPluginInfo(LONG pluginid, void *buffer, LONG size)
{
	return C4DOS.Ge->ReadPluginInfo(pluginid,(CHAR*)buffer,size);
}

Bool WritePluginInfo(LONG pluginid, void *buffer, LONG size)
{
	return C4DOS.Ge->WritePluginInfo(pluginid,(CHAR*)buffer,size);
}

Bool GeGetMovieInfo(const Filename &fn, LONG *frames, LONG *fps)
{
	if (!fn.Get()) return FALSE;
	return C4DOS.Ge->GetMovieInfo(fn.Get(),frames,fps);
}

Bool GeRegistryAdd(LONG sub_id, LONG main_id, void *data)
{
	return C4DOS.Ge->RegistryAdd(sub_id,main_id,data);
}

Bool GeRegistryRemove(LONG sub_id, LONG main_id)
{
	return C4DOS.Ge->RegistryRemove(sub_id,main_id);
}

Registry *GeRegistryFind(LONG sub_id, LONG main_id)
{
	return C4DOS.Ge->RegistryFind(sub_id,main_id);
}

Registry *GeRegistryFindLast(LONG main_id)
{
	return C4DOS.Ge->RegistryFindLast(main_id);
}

Registry *GeRegistryFindFirst(LONG main_id)
{
	return C4DOS.Ge->RegistryFindFirst(main_id);
}

Registry *GeRegistryFindPrev(Registry *last)
{
	return C4DOS.Ge->RegistryFindPrev(last);
}

Registry *GeRegistryFindNext(Registry *last)
{
	return C4DOS.Ge->RegistryFindNext(last);
}

Bool GeRegistryGetAutoID(LONG *id)
{
	return C4DOS.Ge->RegistryGetAutoID(id);
}

LONG Registry::GetMainID(void)
{
	LONG main_id,sub_id;
	void *data;
	if (!C4DOS.Ge->RegistryGetData(this,&main_id,&sub_id,&data)) return 0;
	return main_id;
}

LONG Registry::GetSubID(void)
{
	LONG main_id,sub_id;
	void *data;
	if (!C4DOS.Ge->RegistryGetData(this,&main_id,&sub_id,&data)) return 0;
	return sub_id;
}

void *Registry::GetData(void)
{
	LONG main_id,sub_id;
	void *data;
	if (!C4DOS.Ge->RegistryGetData(this,&main_id,&sub_id,&data)) return NULL;
	return data;
}
