#include "FindFile.h"

using namespace Win;

FindData *	FindFile::BeginSearch(char const *criteria)
{
	_criteria = criteria;
	return BeginSearch();
}

FindData *	FindFile::BeginSearch ()
{
	_data = new FindData;
	_handle = ::FindFirstFile(_criteria.c_str(), _data);
	if(_handle == INVALID_HANDLE_VALUE)
	{
		_handle = 0;
		delete _data;
		return 0;
	}
	return _data;
}

FindData *	FindFile::ContinueSearch ()
{
	if(!_handle)
		return 0;

	if( ::FindNextFile(_handle, _data) )
		return _data;
	return 0;
}

void		FindFile::EndSearch()
{
	if(_handle)
	{
		::FindClose(_handle);
		_handle = 0;
		delete _data;
		_data = 0;
		_criteria = "";
	}
}

// Call EndSearch() after use
char const *	FindFile::SimpleSearch (char const *criteria)
{
	if(_handle)
		this->EndSearch();

	_data = new FindData;
	_handle = ::FindFirstFile(criteria, _data);
	if(_handle == INVALID_HANDLE_VALUE)
		return NULL;
	return _data->FileName();
}
